
// +----------------------------------------------------------------------------------------+ //
// |    .-._______                           XARD777                          _______.-.    | //
// |---( )_)______)                 Knowledge of the ancients                (______(_( )---| //
// |  (    ()___)                              \/                             (___()    )  | //
// |       ()__)                              (o o)                             (__()       | //
// |--(___()_)__________________________oOOo___(_)___oOOo_________________________(_()___)--| //
// |_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|____|_____| //
// |                                                                                   2011 | //
// |----------------------------------------------------------------------------------------| //
// |                 File:     !BDP OPEN PIPS.mq4                                           | //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// |                           for Build 229 (current version)                              | //
// |                                                               [BILLION DOLLAR PROJECT] | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window

color    PanelColor   = C'7,60,100';
extern color    PanelColor2  = C'7,40,80';//SteelBlue;//C'60,20,60';//C'55,100,150';

// ------------------------------------------------------------------------------------------ //
//                            E X T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

extern string  Note1                   = "Insert period 60, 1440 etc";
extern int     period                  = 1440;
extern string  fpair01                 = "EURUSD";
extern string  fpair02                 = "NZDUSD";
extern string  fpair03                 = "AUDUSD";
extern string  fpair04                 = "GBPUSD";
extern string  fpair05                 = "USDJPY";
extern string  fpair06                 = "USDCAD";
extern string  fpair07                 = "USDCHF";
extern string  fpair08                 = "GOLD";

extern color   Negative.Pips           = Orange;
extern color   Positive.Pips           = DeepSkyBlue;
extern int     Move.Panel.Up.Down      = 15;
extern int     Move.Panel.Left.Right   = -2;
extern bool    show.background.panel   = true;

extern string  Note2 = "DST started on Sunday, 27 March 2011, 01:00 local standard time";
extern string  Note3 = "DST ends on Sunday, 30 October 2011, 02:00 local daylight time"; 
extern double  TimeShiftMins           = 0;
// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

int  WhatWindow     = 0;
int  WhatCorner     = 2;
int  shift;
double col;
double      DecNos01,
            DecNos02,
            DecNos03,
            DecNos04,
            DecNos05,
            DecNos06,
            DecNos07,
            DecNos08;
            
datetime    StartTime;            
            
// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

   int init()
   {
   IndicatorShortName("Pips-Info");   
   
   StartTime = iTime(NULL,period,0);  
   if (TimeShiftMins != 0) { StartTime += (TimeShiftMins*60.00); }
    
   return(0);
   }

// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //

   int deinit()
   {
   deleteObjects();
   return(0);
   }

// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

   int start()
   {
   
   if (StringFind (fpair01,"JPY", 0) != -1){ DecNos01 = 100;}
   else { DecNos01 = 10000; }
   if (StringFind (fpair02,"JPY", 0) != -1){ DecNos02 = 100;}
   else { DecNos02 = 10000; }
   if (StringFind (fpair03,"JPY", 0) != -1){ DecNos03 = 100;}
   else { DecNos03 = 10000; }
   if (StringFind (fpair04,"JPY", 0) != -1){ DecNos04 = 100;}
   else { DecNos04 = 10000; }
   if (StringFind (fpair05,"JPY", 0) != -1){ DecNos05 = 100;}
   else { DecNos05 = 10000; }
   if (StringFind (fpair06,"JPY", 0) != -1){ DecNos06 = 100;}
   else { DecNos06 = 10000; }
   if (StringFind (fpair07,"JPY", 0) != -1){ DecNos07 = 100;}
   else { DecNos07 = 10000; }
   if (StringFind (fpair08,"JPY", 0) != -1){ DecNos08 = 100;}
   else { DecNos08 = 100; } 
        
   int    counted_bars=IndicatorCounted();
               
// ------------------------------------------------------------------------------------------ // 
   if(show.background.panel){
   
   CreateBX1_Labels( "Pips003",11+Move.Panel.Left.Right,42+Move.Panel.Up.Down); 
   ObjectSetText("Pips003", "gg", 44, "Webdings", PanelColor2);
   
   CreateBX1_Labels( "Pips003a",11+Move.Panel.Left.Right,100+Move.Panel.Up.Down); 
   ObjectSetText("Pips003a", "gg", 44, "Webdings", PanelColor2);
   
   CreateBX1_Labels( "Pips003b",11+Move.Panel.Left.Right,108+Move.Panel.Up.Down); 
   ObjectSetText("Pips003b", "gg", 44, "Webdings", PanelColor2);
      
   }//End show.background.panel
   
// ------------------------------------------------------------------------------------------ // 
   double pair01 = (iClose(fpair01, PERIOD_M1,0) - iOpen(fpair01, PERIOD_M1, iBarShift(fpair01, PERIOD_M1, StartTime)))* DecNos01;
        
   if (pair01 >0) col = Positive.Pips;
   else if (pair01 <0) col = Negative.Pips;
     
   CreateBX2_Labels( "Pips005",64+Move.Panel.Left.Right,42+Move.Panel.Up.Down); 
   ObjectSetText("Pips005", fpair01, 10, "Arial Black", col);
   CreateBX1_Labels( "Pips006",16+Move.Panel.Left.Right,42+Move.Panel.Up.Down); 
   ObjectSetText("Pips006", DoubleToStr(pair01,0), 10, "Arial Black", col);  
// ------------------------------------------------------------------------------------------ //
   double pair02 = (iClose(fpair02, PERIOD_M1,0) - iOpen(fpair02, PERIOD_M1, iBarShift(fpair02, PERIOD_M1, StartTime)))* DecNos02;
       
   if (pair02 >0) col = Positive.Pips;
   else if (pair02 <0) col = Negative.Pips;
     
   CreateBX2_Labels( "Pips007",64+Move.Panel.Left.Right,57+Move.Panel.Up.Down); 
   ObjectSetText("Pips007", fpair02, 10, "Arial Black", col);
   CreateBX1_Labels( "Pips008",16+Move.Panel.Left.Right,57+Move.Panel.Up.Down); 
   ObjectSetText("Pips008", DoubleToStr(pair02,0), 10, "Arial Black", col);
// ------------------------------------------------------------------------------------------ //   
   double pair03 = (iClose(fpair03, PERIOD_M1,0) - iOpen(fpair03, PERIOD_M1, iBarShift(fpair03, PERIOD_M1, StartTime)))* DecNos03;
   
   if (pair03 >0) col = Positive.Pips;
   else if (pair03 <0) col = Negative.Pips;
     
   CreateBX2_Labels( "Pips009",64+Move.Panel.Left.Right,72+Move.Panel.Up.Down); 
   ObjectSetText("Pips009", fpair03, 10, "Arial Black", col);
   CreateBX1_Labels( "Pips010",16+Move.Panel.Left.Right,72+Move.Panel.Up.Down); 
   ObjectSetText("Pips010", DoubleToStr(pair03,0), 10, "Arial Black", col);
// ------------------------------------------------------------------------------------------ //   
   double pair04 = (iClose(fpair04, PERIOD_M1,0) - iOpen(fpair04, PERIOD_M1, iBarShift(fpair04, PERIOD_M1, StartTime)))* DecNos04;
    
   if (pair04 >0) col = Positive.Pips;
   else if (pair04 <0) col = Negative.Pips;
     
   CreateBX2_Labels( "Pips011",64+Move.Panel.Left.Right,87+Move.Panel.Up.Down); 
   ObjectSetText("Pips011", fpair04, 10, "Arial Black", col);
   CreateBX1_Labels( "Pips012",16+Move.Panel.Left.Right,87+Move.Panel.Up.Down); 
   ObjectSetText("Pips012", DoubleToStr(pair04,0), 10, "Arial Black", col);   
// ------------------------------------------------------------------------------------------ //
   double pair05 = (iClose(fpair05, PERIOD_M1,0) - iOpen(fpair05, PERIOD_M1, iBarShift(fpair05, PERIOD_M1, StartTime)))* DecNos05;
   
   if (pair05 >0) col = Positive.Pips;
   else if (pair05 <0) col = Negative.Pips;
    
   CreateBX2_Labels( "Pips013",64+Move.Panel.Left.Right,102+Move.Panel.Up.Down); 
   ObjectSetText("Pips013", fpair05, 10, "Arial Italic", col);
   CreateBX1_Labels( "Pips014",16+Move.Panel.Left.Right,102+Move.Panel.Up.Down); 
   ObjectSetText("Pips014", DoubleToStr(pair05,0), 10, "Arial Italic", col);
// ------------------------------------------------------------------------------------------ //
   double pair06 = (iClose(fpair06, PERIOD_M1,0) - iOpen(fpair06, PERIOD_M1, iBarShift(fpair06, PERIOD_M1, StartTime)))* DecNos06;
      
   if (pair06 >0) col = Positive.Pips;
   else if (pair06 <0) col = Negative.Pips;
     
   CreateBX2_Labels( "Pips015",64+Move.Panel.Left.Right,117+Move.Panel.Up.Down); 
   ObjectSetText("Pips015", fpair06, 10, "Arial Italic", col);
   CreateBX1_Labels( "Pips016",16+Move.Panel.Left.Right,117+Move.Panel.Up.Down); 
   ObjectSetText("Pips016", DoubleToStr(pair06,0), 10, "Arial Italic", col);
// ------------------------------------------------------------------------------------------ //
   double pair07 = (iClose(fpair07, PERIOD_M1,0) - iOpen(fpair07, PERIOD_M1, iBarShift(fpair07, PERIOD_M1, StartTime)))* DecNos07;
   
   if (pair07 >0) col = Positive.Pips;
   else if (pair07 <0) col = Negative.Pips; 
    
   CreateBX2_Labels( "Pips017",64+Move.Panel.Left.Right,132+Move.Panel.Up.Down); 
   ObjectSetText("Pips017", fpair07, 10, "Arial Italic", col);
   CreateBX1_Labels( "Pips018",16+Move.Panel.Left.Right,132+Move.Panel.Up.Down); 
   ObjectSetText("Pips018", DoubleToStr(pair07,0), 10, "Arial Italic", col);
// ------------------------------------------------------------------------------------------ //
   double pair08 = (iClose(fpair08, PERIOD_M1,0) - iOpen(fpair08, PERIOD_M1, iBarShift(fpair08, PERIOD_M1, StartTime)))* DecNos08;
   
   if (pair08 >0) col = Positive.Pips;
   else if (pair08 <0) col = Negative.Pips;
     
   CreateBX2_Labels( "Pips019",64+Move.Panel.Left.Right,147+Move.Panel.Up.Down); 
   ObjectSetText("Pips019", fpair08, 10, "Arial Black", col);
   CreateBX1_Labels( "Pips020",16+Move.Panel.Left.Right,147+Move.Panel.Up.Down); 
   ObjectSetText("Pips020", DoubleToStr(pair08,0), 10, "Arial Black", col);
// ------------------------------------------------------------------------------------------ //

   }
   return(0);  

   int CreateBX1_Labels( string K, int x, int y ) {
   ObjectCreate( K, OBJ_LABEL, WhatWindow, 0, 0 );
   ObjectSet( K, OBJPROP_CORNER, WhatCorner);
   ObjectSet( K, OBJPROP_XDISTANCE,x+Move.Panel.Left.Right);
   ObjectSet( K, OBJPROP_YDISTANCE,y+Move.Panel.Up.Down);
   ObjectSet( K, OBJPROP_BACK, false );
   }
   
   int CreateBX2_Labels( string K2, int x2, int y2 ) {
   ObjectCreate( K2, OBJ_LABEL, WhatWindow, 0, 0 );
   ObjectSet( K2, OBJPROP_CORNER, WhatCorner);
   ObjectSet( K2, OBJPROP_XDISTANCE,x2+Move.Panel.Left.Right);
   ObjectSet( K2, OBJPROP_YDISTANCE,y2+Move.Panel.Up.Down);
   ObjectSet( K2, OBJPROP_BACK, false );
   }
// ------------------------------------------------------------------------------------------ //   
   void deleteObjects(){
   
    ObjectDelete("Pips001"); 
    ObjectDelete("Pips002"); 
    ObjectDelete("Pips003");
    ObjectDelete("Pips003a");
    ObjectDelete("Pips003b"); 
    ObjectDelete("Pips004");
    ObjectDelete("Pips005"); 
    ObjectDelete("Pips006"); 
    ObjectDelete("Pips007"); 
    ObjectDelete("Pips008"); 
    ObjectDelete("Pips009"); 
    ObjectDelete("Pips010"); 
    ObjectDelete("Pips011"); 
    ObjectDelete("Pips012"); 
    ObjectDelete("Pips013"); 
    ObjectDelete("Pips014"); 
    ObjectDelete("Pips015");
    ObjectDelete("Pips016");
    ObjectDelete("Pips017");
    ObjectDelete("Pips018");
    ObjectDelete("Pips019");
    ObjectDelete("Pips020");
    }
// ------------------------------------------------------------------------------------------ //
//                                     E N D   P R O G R A M                                  //
// ------------------------------------------------------------------------------------------ //
/*                                                         
                                        ud$$$**BILLION$bc.                          
                                    u@**"        PROJECT$$Nu                       
                                  J                ""#$$$$$$r                     
                                 @                       $$$$b                    
                               .F                        ^*3$$$                   
                              :% 4                         J$$$N                  
                              $  :F                       :$$$$$                  
                             4F  9                       J$$$$$$$                 
                             4$   k             4$$$$bed$$$$$$$$$                 
                             $$r  'F            $$$$$$$$$$$$$$$$$r                
                             $$$   b.           $$$$$$$$$$$$$$$$$N                
                             $$$$$k 3eeed$$b    XARD777."$$$$$$$$$                
              .@$**N.        $$$$$" $$$$$$F'L $$$$$$$$$$$  $$$$$$$                
              :$$L  'L       $$$$$ 4$$$$$$  * $$$$$$$$$$F  $$$$$$F         edNc   
             @$$$$N  ^k      $$$$$  3$$$$*%   $F4$$$$$$$   $$$$$"        d"  z$N  
             $$$$$$   ^k     '$$$"   #$$$F   .$  $$$$$c.u@$$$          J"  @$$$$r 
             $$$$$$$b   *u    ^$L            $$  $$$$$$$$$$$$u@       $$  d$$$$$$ 
              ^$$$$$$.    "NL   "N. z@*     $$$  $$$$$$$$$$$$$P      $P  d$$$$$$$ 
                 ^"*$$$$b   '*L   9$E      4$$$  d$$$$$$$$$$$"     d*   J$$$$$r   
                      ^$$$$u  '$.  $$$L     "#" d$$$$$$".@$$    .@$"  z$$$$*"     
                        ^$$$$. ^$N.3$$$       4u$$$$$$$ 4$$$  u$*" z$$$"          
                          '*$$$$$$$$ *$b      J$$$$$$$b u$$P $"  d$$P             
                             #$$$$$$ 4$ 3*$"$*$ $"$'c@@$$$$ .u@$$$P               
                               "$$$$  ""F~$ $uNr$$$^&J$$$$F $$$$#                 
                                 "$$    "$$$bd$.$W$$$$$$$$F $$"                   
                                   ?k         ?$$$$$$$$$$$F'*                     
                                    9$$bL     z$$$$$$$$$$$F                       
                                     $$$$    $$$$$$$$$$$$$                        
                                      '#$$c  '$$$$$$$$$"                          
                                       .@"#$$$$$$$$$$$$b                          
                                     z*      $$$$$$$$$$$$N.                       
                                   e"      z$$"  #$$$k  '*$$.                     
                                .u*      u@$P"      '#$$c   "$$c                   
                        u@$*"""       d$$"            "$$$u  ^*$$b.               
                      :$F           J$P"                ^$$$c   '"$$$$$$bL        
                     d$$  ..      @$#                      #$$b         '#$       
                     9$$$$$$b   4$$                          ^$$k         '$      
                      "$$6""$b u$$                             '$    d$$$$$P      
                        '$F $$$$$"                              ^b  ^$$$$b$       
                         '$W$$$$"                                'b@$$$$"         
                                                                  ^$$$*/     